<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DeskHelper: Файл /home/alner/Документы/Командный курсовой проект/deskhelper/deskhelper/app/deskhelper/src/levenshtein.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">DeskHelper
   </div>
   <div id="projectbrief">app for quick and convenient (voice input) access to data, to other app as well as for reminders</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Создано системой Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Поиск');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Поиск');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Функции</a>  </div>
  <div class="headertitle">
<div class="title">Файл levenshtein.cpp</div>  </div>
</div><!--header-->
<div class="contents">

<p>Расстояние Левенштейна  
<a href="#details">Подробнее...</a></p>
<div class="textblock"><code>#include &quot;../deskhelper/include/levenshtein.h&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Граф включаемых заголовочных файлов для levenshtein.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="levenshtein_8cpp__incl.png" border="0" usemap="#_2home_2alner_2_xD0_x94_xD0_xBE_xD0_xBA_xD1_x83_xD0_xBC_xD0_xB5_xD0_xBD_xD1_x82_xD1_x8B_2_xD0_x9A_xD0_xBE_xD0_xBC_xD0_xB0_xD0_xBD_xD0_xB4_xD0_xBD_xD1_x8B_xD0_xB9_01_xD0_xBA_xD1_x83_xD1_x80_xD1_x81_xD0_xBE_xD0_xB2_xD0_xBE_xD0_xB9_01_xD0_xBF_xD1_x80_xD0_xBE_xD0_xB5_xD0_xBA_xD1_x82_2deskhelper_2deskhelper_2app_2deskhelper_2src_2levenshtein_8cpp" alt=""/></div>
<map name="_2home_2alner_2_xD0_x94_xD0_xBE_xD0_xBA_xD1_x83_xD0_xBC_xD0_xB5_xD0_xBD_xD1_x82_xD1_x8B_2_xD0_x9A_xD0_xBE_xD0_xBC_xD0_xB0_xD0_xBD_xD0_xB4_xD0_xBD_xD1_x8B_xD0_xB9_01_xD0_xBA_xD1_x83_xD1_x80_xD1_x81_xD0_xBE_xD0_xB2_xD0_xBE_xD0_xB9_01_xD0_xBF_xD1_x80_xD0_xBE_xD0_xB5_xD0_xBA_xD1_x82_2deskhelper_2deskhelper_2app_2deskhelper_2src_2levenshtein_8cpp" id="_2home_2alner_2_xD0_x94_xD0_xBE_xD0_xBA_xD1_x83_xD0_xBC_xD0_xB5_xD0_xBD_xD1_x82_xD1_x8B_2_xD0_x9A_xD0_xBE_xD0_xBC_xD0_xB0_xD0_xBD_xD0_xB4_xD0_xBD_xD1_x8B_xD0_xB9_01_xD0_xBA_xD1_x83_xD1_x80_xD1_x81_xD0_xBE_xD0_xB2_xD0_xBE_xD0_xB9_01_xD0_xBF_xD1_x80_xD0_xBE_xD0_xB5_xD0_xBA_xD1_x82_2deskhelper_2deskhelper_2app_2deskhelper_2src_2levenshtein_8cpp">
<area shape="rect" title="Расстояние Левенштейна" alt="" coords="5,5,235,76"/>
<area shape="rect" title=" " alt="" coords="41,124,199,165"/>
</map>
</div>
</div>
<p><a href="levenshtein_8cpp_source.html">См. исходные тексты.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Функции</h2></td></tr>
<tr class="memitem:a31e9065c8a8738ec1515a4631de9eace"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="levenshtein_8cpp.html#a31e9065c8a8738ec1515a4631de9eace">levenshtein</a> (QString string1, QString string2, int w, int s, int a, int d)</td></tr>
<tr class="separator:a31e9065c8a8738ec1515a4631de9eace"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9764e7664830fd81c81b9e3e64b869ed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="levenshtein_8cpp.html#a9764e7664830fd81c81b9e3e64b869ed">oldLevenshtein</a> (std::string string1, std::string string2, int w, int s, int a, int d)</td></tr>
<tr class="separator:a9764e7664830fd81c81b9e3e64b869ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Подробное описание</h2>
<div class="textblock"><p>Расстояние Левенштейна </p>
<p>using <a href="https://github.com/torvalds/linux/blob/8a72f3820c4d14b27ad5336aed00063a7a7f1bef/tools/perf/util/levenshtein.c">https://github.com/torvalds/linux/blob/8a72f3820c4d14b27ad5336aed00063a7a7f1bef/tools/perf/util/levenshtein.c</a> </p>

<p class="definition">См. определение в файле <a class="el" href="levenshtein_8cpp_source.html">levenshtein.cpp</a></p>
</div><h2 class="groupheader">Функции</h2>
<a id="a31e9065c8a8738ec1515a4631de9eace"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a31e9065c8a8738ec1515a4631de9eace">&#9670;&nbsp;</a></span>levenshtein()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int levenshtein </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>string1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>string2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>w</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">См. определение в файле <a class="el" href="levenshtein_8cpp_source.html">levenshtein.cpp</a> строка <a class="el" href="levenshtein_8cpp_source.html#l00048">48</a></p>
<div class="fragment"><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">int</span> len1 = string1.size(), len2 = string2.size();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">int</span> *row0 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">int</span> *row1 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">int</span> *row2 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">int</span> i, j;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="comment">//cout &lt;&lt; string1 &lt;&lt; &quot; &quot; &lt;&lt; string2 &lt;&lt; &quot; &quot; &lt;&lt; len1 &lt;&lt; &quot; &quot; &lt;&lt; len2 &lt;&lt; endl;</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordflow">for</span> (j = 0; j &lt;= len2; j++)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        row1[j] = j * a;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">for</span> (i = 0; i &lt; len1; i++) {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keywordtype">int</span> *dummy;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        row2[0] = (i + 1) * d;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordflow">for</span> (j = 0; j &lt; len2; j++) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="comment">/* substitution */</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            row2[j + 1] = row1[j] + s * (string1[i] != string2[j]);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            <span class="comment">/* swap */</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">if</span> (i &gt; 0 &amp;&amp; j &gt; 0 &amp;&amp; string1[i - 1] == string2[j] &amp;&amp;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                    string1[i] == string2[j - 1] &amp;&amp;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                    row2[j + 1] &gt; row0[j - 1] + w)</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;                row2[j + 1] = row0[j - 1] + w;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            <span class="comment">/* deletion */</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keywordflow">if</span> (row2[j + 1] &gt; row1[j + 1] + d)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;                row2[j + 1] = row1[j + 1] + d;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="comment">/* insertion */</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordflow">if</span> (row2[j + 1] &gt; row2[j] + a)</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;                row2[j + 1] = row2[j] + a;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        dummy = row0;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        row0 = row1;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        row1 = row2;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        row2 = dummy;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    }</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    i = row1[len2];</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keyword">delete</span> [] row0;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">delete</span> [] row1;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keyword">delete</span> [] row2;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordflow">return</span> i;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;}</div>
</div><!-- fragment -->
<p class="reference">Используется в <a class="el" href="database_8cpp_source.html#l00447">Database::findCommandWithLevenshteinDistance()</a>.</p>

</div>
</div>
<a id="a9764e7664830fd81c81b9e3e64b869ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9764e7664830fd81c81b9e3e64b869ed">&#9670;&nbsp;</a></span>oldLevenshtein()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int oldLevenshtein </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>string1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>string2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>w</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">См. определение в файле <a class="el" href="levenshtein_8cpp_source.html">levenshtein.cpp</a> строка <a class="el" href="levenshtein_8cpp_source.html#l00093">93</a></p>
<div class="fragment"><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;{</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">int</span> len1 = string1.size(), len2 = string2.size();</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">int</span> *row0 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordtype">int</span> *row1 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">int</span> *row2 = <span class="keyword">new</span> <span class="keywordtype">int</span>[len2 + 1];</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">int</span> i, j;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment">//cout &lt;&lt; string1 &lt;&lt; &quot; &quot; &lt;&lt; string2 &lt;&lt; &quot; &quot; &lt;&lt; len1 &lt;&lt; &quot; &quot; &lt;&lt; len2 &lt;&lt; endl;</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordflow">for</span> (j = 0; j &lt;= len2; j++)</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        row1[j] = j * a;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">for</span> (i = 0; i &lt; len1; i++) {</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordtype">int</span> *dummy;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        row2[0] = (i + 1) * d;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordflow">for</span> (j = 0; j &lt; len2; j++) {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="comment">/* substitution */</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            row2[j + 1] = row1[j] + s * (string1[i] != string2[j]);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            <span class="comment">/* swap */</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="keywordflow">if</span> (i &gt; 0 &amp;&amp; j &gt; 0 &amp;&amp; string1[i - 1] == string2[j] &amp;&amp;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                    string1[i] == string2[j - 1] &amp;&amp;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                    row2[j + 1] &gt; row0[j - 1] + w)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;                row2[j + 1] = row0[j - 1] + w;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            <span class="comment">/* deletion */</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            <span class="keywordflow">if</span> (row2[j + 1] &gt; row1[j + 1] + d)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;                row2[j + 1] = row1[j + 1] + d;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="comment">/* insertion */</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            <span class="keywordflow">if</span> (row2[j + 1] &gt; row2[j] + a)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;                row2[j + 1] = row2[j] + a;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        }</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        dummy = row0;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        row0 = row1;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        row1 = row2;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        row2 = dummy;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    i = row1[len2];</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">delete</span> [] row0;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keyword">delete</span> [] row1;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keyword">delete</span> [] row2;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordflow">return</span> i;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;}</div>
</div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Создано системой &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
